diff --git a/src/modules/Extensions/LastFM.cpp b/src/modules/Extensions/LastFM.cpp
index c44e7fb3..699b863e 100644
--- a/src/modules/Extensions/LastFM.cpp
+++ b/src/modules/Extensions/LastFM.cpp
@@ -29,7 +29,11 @@ Q_DECLARE_METATYPE(LastFM::Scrobble)
 
 #include <QCryptographicHash>
 #include <QStringList>
-#include <QUrlQuery>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QUrlQuery>
+#else
+    #include <QUrl>
+#endif
 #include <QImage>
 
 LastFM::LastFM(Module &module) :
@@ -43,7 +47,7 @@ LastFM::LastFM(Module &module) :
     loginTimer.setSingleShot(true);
     connect(&updateTim, SIGNAL(timeout()), this, SLOT(processScrobbleQueue()));
     connect(&loginTimer, SIGNAL(timeout()), this, SLOT(login()));
-    connect(&QMPlay2Core, &QMPlay2CoreClass::updatePlaying, this, &LastFM::updatePlaying);
+    connect(&QMPlay2Core, SIGNAL(updatePlaying(bool, QString, QString, QString, int, bool, QString, QString)), this, SLOT(updatePlaying(bool, QString, QString, QString, int, bool, QString, QString)));
 }
 
 bool LastFM::set()
@@ -162,6 +166,7 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
         QCryptographicHash::Md5
     ).toHex();
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QUrlQuery updateNowPlayingQuery;
     updateNowPlayingQuery.addQueryItem("method", "track.updatenowplaying");
     updateNowPlayingQuery.addQueryItem("artist", scrobble.artist);
@@ -173,8 +178,20 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
     updateNowPlayingQuery.addQueryItem("sk", session_key);
 
     reply = net.start(audioScrobbler2URL, updateNowPlayingQuery.toString(QUrl::EncodeDelimiters).toUtf8(), NetworkAccess::UrlEncoded);
-    connect(reply, &NetworkReply::finished,
-            reply, &NetworkReply::deleteLater);
+#else
+    QUrl updateNowPlayingQuery;
+    updateNowPlayingQuery.addQueryItem("method", "track.updatenowplaying");
+    updateNowPlayingQuery.addQueryItem("artist", scrobble.artist);
+    updateNowPlayingQuery.addQueryItem("track", scrobble.title);
+    updateNowPlayingQuery.addQueryItem("album", scrobble.album.isEmpty() ? "" : scrobble.album);
+    updateNowPlayingQuery.addQueryItem("duration", duration);
+    updateNowPlayingQuery.addQueryItem("api_key", api_key);
+    updateNowPlayingQuery.addQueryItem("api_sig", apiSig);
+    updateNowPlayingQuery.addQueryItem("sk", session_key);
+
+    reply = net.start(audioScrobbler2URL, updateNowPlayingQuery.encodedQuery(), NetworkAccess::UrlEncoded);
+#endif
+    connect(reply, SIGNAL(finished()), reply, SLOT(deleteLater()));
 
     // scrobble
     const auto ts = QString::number(scrobble.startTime);
@@ -186,6 +203,7 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
         QCryptographicHash::Md5
     ).toHex();
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     QUrlQuery scrobbleQuery;
     scrobbleQuery.addQueryItem("method", "track.scrobble");
     scrobbleQuery.addQueryItem("artist", scrobble.artist);
@@ -197,14 +215,24 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
     scrobbleQuery.addQueryItem("sk", session_key);
 
     reply = net.start(audioScrobbler2URL, scrobbleQuery.toString(QUrl::EncodeDelimiters).toUtf8(), NetworkAccess::UrlEncoded);
+#else
+    QUrl scrobbleQuery;
+    scrobbleQuery.addQueryItem("method", "track.scrobble");
+    scrobbleQuery.addQueryItem("artist", scrobble.artist);
+    scrobbleQuery.addQueryItem("track", scrobble.title);
+    scrobbleQuery.addQueryItem("timestamp", ts);
+    scrobbleQuery.addQueryItem("album", scrobble.album.isEmpty() ? "" : scrobble.album);
+    scrobbleQuery.addQueryItem("api_key", api_key);
+    scrobbleQuery.addQueryItem("api_sig", apiSig);
+    scrobbleQuery.addQueryItem("sk", session_key);
+
+    reply = net.start(audioScrobbler2URL, scrobbleQuery.encodedQuery(), NetworkAccess::UrlEncoded);
+#endif
     reply->setProperty("scrobble", QVariant::fromValue(scrobble));
     m_scrobbleReplies.push_back(reply);
-    connect(reply, &NetworkReply::destroyed,
-            this, [=] {
-        m_scrobbleReplies.removeOne(reply);
-    });
-    connect(reply, &NetworkReply::finished,
-            this, &LastFM::scrobbleFinished);
+    m_scrobbleReplyMap[reply] = reply;
+    connect(reply, SIGNAL(destroyed(QObject*)), this, SLOT(onScrobbleReplyDestroyed()));
+    connect(reply, SIGNAL(finished()), this, SLOT(scrobbleFinished()));
 }
 
 void LastFM::clear()
@@ -225,7 +253,7 @@ void LastFM::updatePlaying(bool play, QString title, QString artist, const QStri
     QString origTitle;
     if (!title.isEmpty() && artist.isEmpty())
     {
-        const int idx = title.indexOf(QStringLiteral(" - "));
+        const int idx = title.indexOf(QString(" - "));
         if (idx > 0)
         {
             origTitle = title;
@@ -256,7 +284,11 @@ void LastFM::updatePlaying(bool play, QString title, QString artist, const QStri
             }
             else for (int i = 0; i < scrobbleQueue.count(); ++i)
                 if (scrobbleQueue[i] == scrobble && currTime - scrobbleQueue[i].startTime < scrobbleSec)
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+                    scrobbleQueue.remove(i);
+#else
                     scrobbleQueue.removeAt(i);
+#endif
             if (scrobbleQueue.isEmpty())
                 updateTim.stop();
             else if (!session_key.isEmpty())
@@ -278,7 +310,7 @@ void LastFM::albumFinished()
     bool coverNotFound = false;
     if (coverReply->hasError())
     {
-        if (!isCoverImage && coverReply->error() == NetworkReply::Error::Connection400)
+        if (!isCoverImage && coverReply->error() == NetworkReply::ErrorConnection400)
             coverNotFound = true;
     }
     else
@@ -288,7 +320,7 @@ void LastFM::albumFinished()
             emit QMPlay2Core.updateCover(taa[0], taa[1], taa[2], reply);
         else
         {
-            for (const QString &size : std::as_const(imageSizes))
+            for (const QString &size : imageSizes)
             {
                 int idx = reply.indexOf(size.toLatin1());
                 if (idx > -1)
@@ -316,7 +348,7 @@ void LastFM::albumFinished()
     if (coverNotFound && !origTitle.isEmpty())
     {
         // Swap title and artist and set "origTitle" to empty (non-null) to not enter into else-if
-        getAlbumCover(taa[1], taa[0], QString(), QStringLiteral(""), false); //This also will delete the old "coverReply"
+        getAlbumCover(taa[1], taa[0], QString(), QString(""), false); //This also will delete the old "coverReply"
         return;
     }
     else if (coverNotFound && !titleAsAlbum && origTitle.isNull())
@@ -341,7 +373,7 @@ void LastFM::loginFinished()
 {
     if (loginReply->hasError())
     {
-        const bool wrongLoginOrPassword = (loginReply->error() == NetworkReply::Error::Connection403);
+        const bool wrongLoginOrPassword = (loginReply->error() == NetworkReply::ErrorConnection403);
         if (!dontShowLoginError || wrongLoginOrPassword)
             QMPlay2Core.logError(tr("LastFM login error.") + (wrongLoginOrPassword ? (" " + tr("Check login and password!")) : QString()));
         if (wrongLoginOrPassword)
@@ -401,3 +433,18 @@ void LastFM::processScrobbleQueue()
     while (!scrobbleQueue.isEmpty())
         updateNowPlayingAndScrobble(scrobbleQueue.dequeue());
 }
+
+void LastFM::onScrobbleReplyDestroyed()
+{
+    QObject *obj = sender();
+    if (!obj)
+        return;
+
+    auto it = m_scrobbleReplyMap.find(obj);
+    if (it != m_scrobbleReplyMap.end())
+    {
+        NetworkReply *reply = it.value();
+        m_scrobbleReplyMap.erase(it);
+        m_scrobbleReplies.removeOne(reply);
+    }
+}
diff --git a/src/modules/Extensions/LastFM.hpp b/src/modules/Extensions/LastFM.hpp
index a2704197..29f965a0 100644
--- a/src/modules/Extensions/LastFM.hpp
+++ b/src/modules/Extensions/LastFM.hpp
@@ -29,7 +29,7 @@
 
 class QImage;
 
-class LastFM final : public QObject, public QMPlay2Extensions
+class LastFM : public QObject, public QMPlay2Extensions
 {
     Q_OBJECT
 public:
@@ -49,7 +49,7 @@ public:
 
     LastFM(Module &module);
 private:
-    bool set() override;
+    bool set();
 
     void getAlbumCover(const QString &title, const QString &artist, const QString &album, const QString &origTitle, bool titleAsAlbum = false);
 
@@ -60,7 +60,7 @@ private:
 
     void clear();
 
-    void updatePlaying(bool play, QString title, QString artist, const QString &album, int length, bool needCover, const QString &fileName, const QString &url);
+    Q_SLOT void updatePlaying(bool play, QString title, QString artist, const QString &album, int length, bool needCover, const QString &fileName, const QString &url);
 
 private slots:
     void albumFinished();
@@ -68,9 +68,12 @@ private slots:
     void scrobbleFinished();
 
     void processScrobbleQueue();
+
+    void onScrobbleReplyDestroyed();
 private:
     NetworkReply *coverReply, *loginReply;
     QList<NetworkReply *> m_scrobbleReplies;
+    QHash<QObject*, NetworkReply*> m_scrobbleReplyMap;
     bool downloadCovers, dontShowLoginError, firstTime;
     QString user, md5pass, session_key;
     QQueue<Scrobble> scrobbleQueue;
diff --git a/src/modules/Extensions/Lyrics.cpp b/src/modules/Extensions/Lyrics.cpp
index a69ec6b1..cd5f2d07 100644
--- a/src/modules/Extensions/Lyrics.cpp
+++ b/src/modules/Extensions/Lyrics.cpp
@@ -20,7 +20,11 @@
 
 #include <Functions.hpp>
 
-#include <QRegularExpression>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QRegularExpression>
+#else
+    #include <QRegExp>
+#endif
 #include <QFile>
 
 #include <algorithm>
@@ -57,8 +61,13 @@ Lyrics::Lyrics(Module &module) :
 {
     SetModule(module);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     connect(&QMPlay2Core, &QMPlay2CoreClass::updatePlaying,
             this, &Lyrics::updatePlaying);
+#else
+    connect(&QMPlay2Core, SIGNAL(updatePlaying(bool, QString, QString, QString, int, bool, QString, QString, QString)),
+            this, SLOT(updatePlaying(bool, QString, QString, QString, int, bool, QString, QString, QString)));
+#endif
     connect(&m_net, SIGNAL(finished(NetworkReply *)), this, SLOT(finished(NetworkReply *)));
 
     m_dW = new DockWidget;
@@ -121,7 +130,7 @@ void Lyrics::updatePlaying(bool play, const QString &title, const QString &artis
         m_artist = artist;
         if (!m_title.isEmpty() && m_artist.isEmpty())
         {
-            const int idx = m_title.indexOf(QStringLiteral(" - "));
+            const int idx = m_title.indexOf(QString(" - "));
             if (idx > 0)
             {
                 m_artist = m_title.mid(0, idx);
@@ -169,7 +178,7 @@ void Lyrics::finished(NetworkReply *reply)
             using Guess = std::tuple<QString, QString, quint8>;
             std::vector<Guess> guesses;
 
-            for (const QString &chunk : std::as_const(list))
+            for (const QString &chunk : list)
             {
                 const QString name = extractTag(chunk, "title");
 
@@ -280,13 +289,13 @@ void Lyrics::finished(NetworkReply *reply)
 
 bool Lyrics::loadLrcFile(const QString &url)
 {
-    if (!url.startsWith(QStringLiteral("file://")))
+    if (!url.startsWith(QString("file://")))
         return false;
 
     const QString localPath = url.mid(7);
     const QString filePath = Functions::filePath(localPath);
     const QString baseName = Functions::fileName(localPath, false);
-    const QString lrcPath = filePath + baseName + QStringLiteral(".lrc");
+    const QString lrcPath = filePath + baseName + QString(".lrc");
 
     QFile file(lrcPath);
     if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
@@ -302,25 +311,45 @@ bool Lyrics::loadLrcFile(const QString &url)
         return false;
 
     const QString data = Functions::textWithFallbackEncoding(rawData);
+#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
     const QStringList lines = data.split('\n', Qt::SkipEmptyParts);
+#else
+    const QStringList lines = data.split('\n', QString::SkipEmptyParts);
+#endif
 
     QString artist, title;
     QStringList lyricsLines;
 
-    const QRegularExpression tagRegex(QStringLiteral(R"(^\[(\w+):(.*)\]$)"));
-    const QRegularExpression timeTagRegex(QStringLiteral(R"(\[\d{1,2}:\d{2}(?:\.\d{1,2})?\])"));
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    const QRegularExpression tagRegex(QString(R"(^\[(\w+):(.*)\]$)"));
+    const QRegularExpression timeTagRegex(QString(R"(\[\d{1,2}:\d{2}(?:\.\d{1,2})?\])"));
+#else
+    // Qt4: No QRegularExpression
+    QRegExp tagRegex(QString(R"(^\[(\w+):(.*)\]$)"));
+    QRegExp timeTagRegex(QString(R"(\[\d{1,2}:\d{2}(?:\.\d{1,2})?\])"));
+#endif
 
     for (const QString &line : lines)
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         const QRegularExpressionMatch match = tagRegex.match(line.trimmed());
-        if (match.hasMatch())
+        const bool hasMatch = match.hasMatch();
+#else
+        const bool hasMatch = (tagRegex.indexIn(line.trimmed()) != -1);
+#endif
+        if (hasMatch)
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             const QString key = match.captured(1);
             const QString value = match.captured(2).trimmed();
+#else
+            const QString key = tagRegex.cap(1);
+            const QString value = tagRegex.cap(2).trimmed();
+#endif
 
-            if (key == QStringLiteral("ar"))
+            if (key == QString("ar"))
                 artist = value;
-            else if (key == QStringLiteral("ti"))
+            else if (key == QString("ti"))
                 title = value;
         }
         else
@@ -336,21 +365,21 @@ bool Lyrics::loadLrcFile(const QString &url)
     if (lyricsLines.isEmpty())
         return false;
 
-    QString html = QStringLiteral("<center>");
+    QString html = QString("<center>");
 
     if (!title.isEmpty() || !artist.isEmpty())
     {
-        html += QStringLiteral("<b>");
+        html += QString("<b>");
         if (!title.isEmpty() && !artist.isEmpty())
-            html += title + QStringLiteral(" - ") + artist;
+            html += title + QString(" - ") + artist;
         else if (!title.isEmpty())
             html += title;
         else
             html += artist;
-        html += QStringLiteral("</b><br/><br/>");
+        html += QString("</b><br/><br/>");
     }
 
-    html += lyricsLines.join(QStringLiteral("<br/>")) + QStringLiteral("</center>");
+    html += lyricsLines.join(QString("<br/>")) + QString("</center>");
     setHtml(html);
 
     return true;
diff --git a/src/modules/Extensions/Lyrics.hpp b/src/modules/Extensions/Lyrics.hpp
index 6c2538f8..2ab6c6ff 100644
--- a/src/modules/Extensions/Lyrics.hpp
+++ b/src/modules/Extensions/Lyrics.hpp
@@ -25,7 +25,7 @@
 #include <QTextEdit>
 #include <QPointer>
 
-class Lyrics final : public QTextEdit, public QMPlay2Extensions
+class Lyrics : public QTextEdit, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -33,15 +33,13 @@ public:
     Lyrics(Module &module);
     ~Lyrics();
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
 private slots:
     void visibilityChanged(bool v);
 
-private:
     void updatePlaying(bool play, const QString &title, const QString &artist, const QString &album, int length, bool needCover, const QString &fileName, const QString &url, const QString &lyrics);
 
-private slots:
     void finished(NetworkReply *reply);
 
 private:
diff --git a/src/modules/Extensions/MPRIS2.cpp b/src/modules/Extensions/MPRIS2.cpp
index 6705aa72..64175446 100644
--- a/src/modules/Extensions/MPRIS2.cpp
+++ b/src/modules/Extensions/MPRIS2.cpp
@@ -114,7 +114,7 @@ MediaPlayer2Player::MediaPlayer2Player(QObject *p) :
 {
     clearMetaData();
     m_data["mpris:trackid"] = QVariant::fromValue<QDBusObjectPath>(trackID);
-    connect(&QMPlay2Core, &QMPlay2CoreClass::updatePlaying, this, &MediaPlayer2Player::updatePlaying);
+    connect(&QMPlay2Core, SIGNAL(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)), this, SLOT(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)));
     connect(&QMPlay2Core, SIGNAL(coverDataFromMediaFile(const QByteArray &)), this, SLOT(coverDataFromMediaFile(const QByteArray &)));
     connect(&QMPlay2Core, SIGNAL(playStateChanged(const QString &)), this, SLOT(playStateChanged(const QString &)));
     connect(&QMPlay2Core, SIGNAL(coverFile(const QString &)), this, SLOT(coverFile(const QString &)));
diff --git a/src/modules/Extensions/MPRIS2.hpp b/src/modules/Extensions/MPRIS2.hpp
index 5e4c87d3..9fd67a64 100644
--- a/src/modules/Extensions/MPRIS2.hpp
+++ b/src/modules/Extensions/MPRIS2.hpp
@@ -23,7 +23,7 @@
 
 #include <memory>
 
-class MediaPlayer2Root final : public QDBusAbstractAdaptor
+class MediaPlayer2Root : public QDBusAbstractAdaptor
 {
     Q_OBJECT
 
@@ -62,7 +62,7 @@ private:
 
 /**/
 
-class MediaPlayer2Player final : public QDBusAbstractAdaptor
+class MediaPlayer2Player : public QDBusAbstractAdaptor
 {
     Q_OBJECT
 
@@ -115,9 +115,8 @@ public slots:
     void OpenUri(const QString &Uri);
 signals:
     void Seeked(qint64 Position);
-private:
-    void updatePlaying(bool play, const QString &title, const QString &artist, const QString &album, int length, bool needCover, const QString &fileName, const QString &url);
 private slots:
+    void updatePlaying(bool play, const QString &title, const QString &artist, const QString &album, int length, bool needCover, const QString &fileName, const QString &url);
     void coverDataFromMediaFile(const QByteArray &cover);
     void playStateChanged(const QString &plState);
     void coverFile(const QString &filePath);
@@ -140,7 +139,7 @@ private:
 
 /**/
 
-class MPRIS2Interface final : public QObject
+class MPRIS2Interface : public QObject
 {
 public:
     MPRIS2Interface();
@@ -158,13 +157,13 @@ private:
 
 #include <QMPlay2Extensions.hpp>
 
-class MPRIS2 final : public QMPlay2Extensions
+class MPRIS2 : public QMPlay2Extensions
 {
 public:
     MPRIS2(Module &module);
     ~MPRIS2();
 private:
-    bool set() override;
+    bool set();
 
     std::unique_ptr<MPRIS2Interface> mpris2Interface;
 };
diff --git a/src/modules/Extensions/MediaBrowser.cpp b/src/modules/Extensions/MediaBrowser.cpp
index e5a9017d..806bef97 100644
--- a/src/modules/Extensions/MediaBrowser.cpp
+++ b/src/modules/Extensions/MediaBrowser.cpp
@@ -42,10 +42,10 @@
 #include <QDir>
 #include <QUrl>
 
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonValue>
-#include <QJsonArray>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+#include <QJsonValue.h>
+#include <QJsonArray.h>
 
 #include <algorithm>
 
@@ -786,7 +786,7 @@ void MediaBrowser::netFinished(NetworkReply *reply)
             m_pages->hide();
             m_loadAllB->hide();
             m_progressB->hide();
-            if (reply->error() == NetworkReply::Error::Connection404)
+            if (reply->error() == NetworkReply::ErrorConnection404)
                 emit QMPlay2Core.sendMessage(tr("Website doesn't exist"), MediaBrowserName, 3);
             else
                 emit QMPlay2Core.sendMessage(tr("Connection error"), MediaBrowserName, 3);
diff --git a/src/modules/Extensions/MediaBrowser.hpp b/src/modules/Extensions/MediaBrowser.hpp
index 93ff96e7..6a948e43 100644
--- a/src/modules/Extensions/MediaBrowser.hpp
+++ b/src/modules/Extensions/MediaBrowser.hpp
@@ -33,7 +33,7 @@ class MediaBrowserJS;
 
 /**/
 
-class MediaBrowserResults final : public QTreeWidget
+class MediaBrowserResults : public QTreeWidget
 {
     Q_OBJECT
 
@@ -69,7 +69,7 @@ private:
 class QToolButton;
 class QComboBox;
 
-class MediaBrowserPages final : public QWidget
+class MediaBrowserPages : public QWidget
 {
     Q_OBJECT
 
@@ -114,7 +114,7 @@ class QCompleter;
 class QTextEdit;
 class LineEdit;
 
-class MediaBrowser final : public QWidget, public QMPlay2Extensions
+class MediaBrowser : public QWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
@@ -123,14 +123,14 @@ public:
     ~MediaBrowser();
 
 private:
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget();
 
-    bool canConvertAddress() const override;
+    bool canConvertAddress() const;
 
-    QList<AddressPrefix> addressPrefixList(bool) const override;
-    void convertAddress(const QString &prefix, const QString &url, const QString &param, QString *streamUrl, QString *name, QIcon *icon, QString *extension, IOController<> *ioCtrl) override;
+    QList<AddressPrefix> addressPrefixList(bool) const;
+    void convertAddress(const QString &prefix, const QString &url, const QString &param, QString *streamUrl, QString *name, QIcon *icon, QString *extension, IOController<> *ioCtrl);
 
-    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &) override;
+    QVector<QAction *> getActions(const QString &, double, const QString &, const QString &, const QString &);
 
 private:
     inline void setCompleterListCallback();
